import {
  InstanceNameType,
} from '@overflow/commons/di/type';

import {InstanceDefinition} from './instance_definition';

export interface InstanceDefinitionRegistry {
  registerInstanceDefinition(name: InstanceNameType, instanceDefinition:InstanceDefinition): void;
  removeInstanceDefinition(name: InstanceNameType): void;
  getInstanceDefinition(name: InstanceNameType): InstanceDefinition;
  containsInstanceDefinition(name: InstanceNameType): boolean;
  getInstanceDefinitionNames(): InstanceNameType[];
  getInstanceDefinitionCount(): number;
  isInstanceNameInUse(name: InstanceNameType): boolean;
}
